Index: lib/spatial/mapbuilder/lib/model/Context.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/Context.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/Context.js	(revision 4307)
@@ -1,11 +1,14 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Context.js 3887 2008-02-27 18:18:53Z ahocevar $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
- * Stores a Web Map Context (WMC) document as defined by the Open GIS Consortium
- * http://opengis.org and extensions the the WMC.  
+ * Stores a Web Map Context (WMC) document as defined by the Open Geospatial Consortium
+ * (http://www.opengeospatial.org/) and extensions the the WMC.
  *
  * Listeners supported by this model:
  * "refresh" called when window parameters (width/height, bbox) are changed
@@ -16,7 +19,7 @@
  * @author Cameron Shorter
  * @param modelNode Pointer to the xml node for this model from the config file.
  * @param parent    The parent model for the object.
-  * 
+  *
  */
 function Context(modelNode, parent) {
   // Inherit the ModelBase functions and parameters
@@ -26,28 +29,28 @@
 
   /**
    * Change a Layer's visibility.
-   * @param layerName  The name of the layer that is to be changed
+   * @param layerId  The name of the layer that is to be changed
    * @param hidden     String with the value to be set; 1=hidden, 0=visible.
    */
-  this.setHidden=function(layerName, hidden){
+  this.setHidden=function(layerId, hidden){
     // Set the hidden attribute in the Context
     var hiddenValue = "0";
     if (hidden) hiddenValue = "1";
-      
-    var layer=this.doc.selectSingleNode("/wmc:ViewContext/wmc:LayerList/wmc:Layer[wmc:Name='"+layerName+"']");
+
+    var layer = this.getLayer(layerId);
     if (layer) layer.setAttribute("hidden", hiddenValue);
     // Call the listeners
-    this.callListeners("hidden", layerName);
+    this.callListeners("hidden", layerId);
   }
 
   /**
    * Get the layer's visiblity attribute value.
-   * @param layerName  The name of the layer that is to be changed
+   * @param layerId  The name of the layer that is to be changed
    * @return hidden  String with the value; 1=hidden, 0=visible.
    */
-  this.getHidden=function(layerName){
+  this.getHidden=function(layerId){
     var hidden=1;
-    var layer=this.doc.selectSingleNode("/wmc:ViewContext/wmc:LayerList/wmc:Layer[wmc:Name='"+layerName+"']");
+    var layer = this.getLayer(layerId);
     if (layer) hidden = layer.getAttribute("hidden");
     return hidden;
   }
@@ -57,8 +60,9 @@
    * @return BoundingBox array with the sequence (xmin,ymin,xmax,ymax).
    */
   this.getBoundingBox=function() {
+    var bbox = new Array();
+    // Extract BoundingBox from the context
     var boundingBox=this.doc.selectSingleNode("/wmc:ViewContext/wmc:General/wmc:BoundingBox");
-    bbox = new Array();
     bbox[0]=parseFloat(boundingBox.getAttribute("minx"));
     bbox[1]=parseFloat(boundingBox.getAttribute("miny"));
     bbox[2]=parseFloat(boundingBox.getAttribute("maxx"));
@@ -72,7 +76,6 @@
    */
   this.setBoundingBox=function(boundingBox) {
     // Set BoundingBox in context
-    //bbox=this.doc.documentElement.getElementsByTagName("BoundingBox").item(0);
     var bbox=this.doc.selectSingleNode("/wmc:ViewContext/wmc:General/wmc:BoundingBox");
     bbox.setAttribute("minx", boundingBox[0]);
     bbox.setAttribute("miny", boundingBox[1]);
@@ -88,15 +91,13 @@
    */
   this.initBbox=function(objRef) {
     // Set BoundingBox in context from URL CGI params
-    if (window.cgiArgs["bbox"]) {     //set as minx,miny,maxx,maxy
+    if (window.cgiArgs["bbox"]) {   //set as minx,miny,maxx,maxy
       var bbox = window.cgiArgs["bbox"].split(',');
-      var ul = new Array(parseFloat(bbox[0]),parseFloat(bbox[3]));
-      var lr = new Array(parseFloat(bbox[2]),parseFloat(bbox[1]));
-      objRef.extent.zoomToBox(ul, lr);
+      objRef.setBoundingBox(bbox);
     }
   }
-  //PGC this.addListener( "loadModel", this.initBbox, this );
-  this.addListener( "contextLoaded", this.initBbox, this );
+  this.addListener( "loadModel", this.initBbox, this );
+  //this.addListener( "contextLoaded", this.initBbox, this );
 
   /**
    * Set the aoi param and call the refresh listeners
@@ -113,7 +114,7 @@
   //MA this.addListener( "contextLoaded", this.initAoi, this );
 
   /**
-   * Set the Spacial Reference System for the context document.
+   * Set the Spatial Reference System for the context document.
    * @param srs The Spatial Reference System.
    */
   this.setSRS=function(srs) {
@@ -123,16 +124,26 @@
   }
 
   /**
-   * Get the Spacial Reference System from the context document.
+   * Get the Spatial Reference System from the context document.
    * @return srs The Spatial Reference System.
    */
   this.getSRS=function() {
     var bbox=this.doc.selectSingleNode("/wmc:ViewContext/wmc:General/wmc:BoundingBox");
     srs=bbox.getAttribute("SRS");
+    srs = srs ? srs : 'EPSG:4326';
     return srs;
   }
 
   /**
+   * Get the Projection object from the context document.
+   * @return Proj Object of  The Spatial Reference System.
+   */
+  this.initProj=function(objRef) {
+    objRef.proj=new OpenLayers.Projection(objRef.getSRS());
+  }
+  this.addFirstListener( "loadModel", this.initProj, this );
+
+  /**
    * Get the Window width.
    * @return width The width of map window from the context document
    */
@@ -143,7 +154,7 @@
 
   /**
    * Set the Window width.
-   * @param width The width of map window (therefore of map layer images).
+   * @param width The width of map window to set in the context document
    */
   this.setWindowWidth=function(width) {
     var win=this.doc.selectSingleNode("/wmc:ViewContext/wmc:General/wmc:Window");
@@ -171,11 +182,45 @@
   }
 
   /**
+   * Returns the width/height of the map window as an array
+   */
+  this.getWindowSize=function() {
+    var win=this.doc.selectSingleNode("/wmc:ViewContext/wmc:General/wmc:Window");
+    return new Array(win.getAttribute("width"), win.getAttribute("height"));
+  }
+
+  /**
+   * Set the Window width and height in one function call to avoid a resize event in between
+   * setting width and height, because that causes checkBbox to be triggered, which adjusts the
+   * bbox then when it should not yet be adjusted.
+   * Added by VTS for dynamic map window resizing (AutoResize tool)
+   * @param size Size of the map window as (width, height) array
+   */
+  this.setWindowSize=function(size) {
+    var width = size[0];
+    var height = size[1];
+    var win=this.doc.selectSingleNode("/wmc:ViewContext/wmc:General/wmc:Window");
+    win.setAttribute("width", width);
+    win.setAttribute("height", height);
+    this.callListeners("resize");
+  }
+
+  /**
+   * Returns the Layer node with the specified name from the list of nodes
+   * selected by the nodeSelectXpath from the capabilities doc.
+   * @param featureName name of the featureType to look up
+   * @return the Layer node with the specified name.
+   */
+  this.getFeatureNode = function(featureName) {
+    return this.doc.selectSingleNode(this.nodeSelectXpath+"[wmc:Name='"+featureName+"']");
+  }
+
+  /**
    * Returns the serverUrl for the layer passed in as the feature argument.
    * @param requestName ignored for context docs (only GetMap supported)
    * @param method ignored for context docs (only GET supported)
    * @param feature the Layer node from the context doc
-   * @return URL for the GetMap request 
+   * @return URL for the GetMap request
    */
   this.getServerUrl = function(requestName, method, feature) {
     return feature.selectSingleNode("wmc:Server/wmc:OnlineResource").getAttribute("xlink:href");
@@ -186,7 +231,7 @@
    * @param feature the Layer node from the context doc
    * @return the WMS GetMap version for the Layer.
    */
-  this.getVersion = function(feature) {  
+  this.getVersion = function(feature) {
     return feature.selectSingleNode("wmc:Server").getAttribute("version");
   }
 
@@ -204,7 +249,7 @@
    * @return the list with queryable layers
    */
   this.getQueryableLayers = function() {
-    var listNodeArray = this.doc.selectNodes("/wmc:ViewContext/wmc:LayerList/wmc:Layer[attribute::queryable='1']/wmc:Name");
+    var listNodeArray = this.doc.selectNodes("/wmc:ViewContext/wmc:LayerList/wmc:Layer[attribute::queryable='1']");
     return listNodeArray;
   }
 
@@ -220,35 +265,79 @@
 
   /**
    * Method to get a layer with the specified name in the context doc
-   * @param layerName the layer to be returned
+   * @param layerId the id of the layer to be returned
    * @return the list with all layers
    */
-  this.getLayer = function(layerName) {
-    var layer = this.doc.selectSingleNode("/wmc:ViewContext/wmc:LayerList/wmc:Layer[wmc:Name='"+layerName+"']");
+  this.getLayer = function(layerId) {
+    var layer = this.doc.selectSingleNode("/wmc:ViewContext/wmc:LayerList/wmc:Layer[@id='"+layerId+"']");
+    if (layer == null) {
+      layer = this.doc.selectSingleNode("/wmc:ViewContext/wmc:LayerList/wmc:Layer[wmc:Name='"+layerId+"']");
+    }
     //TBD: add in time stamp
     return layer;
   }
 
   /**
+   * Method to get a layer id with the specified id/name in the context doc
+   * @param layerName the name of the layer of which the id is to be returned
+   * @return the id of the layer || false
+   */
+  this.getLayerIdByName = function(layerName) {
+    var layer = this.getLayer(layerName);
+    var id;
+    if (layer) {
+      id = layer.getAttribute("id");
+    }
+
+    return id || false;
+  }
+
+  /**
    * Method to add a Layer to the LayerList
    * @param layerNode the Layer node from another context doc or capabiltiies doc
    */
   this.addLayer = function(objRef, layerNode) {
+
     var parentNode = objRef.doc.selectSingleNode("/wmc:ViewContext/wmc:LayerList");
-    parentNode.appendChild(layerNode.cloneNode(true));
+    parentNode.appendChild(layerNode);
+
+    // Generate layer id if layer doesn't have an id
+    if (!layerNode.getAttribute("id")) {
+      var randomNumber = Math.round(10000 * Math.random());
+      id = Mapbuilder.getProperty(layerNode, "wmc:Name") + "_" + randomNumber; 
+      layerNode.setAttribute("id", id);
+    }
+
     objRef.modified = true;
     //objRef.callListeners("refresh");
   }
   this.addFirstListener( "addLayer", this.addLayer, this );
 
+ /**
+   * Method to add a Sld tag to the StyleList
+   * @param layerName the Layer name from another context doc or capabiltiies doc
+   */
+  this.addSLD = function(objRef,sldNode) {
+    // alert("context addSLD : "+objRef.id);
+    var layerName=Mapbuilder.getProperty(sldNode, "//Name");
+    var parentNode = objRef.doc.selectSingleNode("//wmc:Layer[wmc:Name='"+layerName+"']");
+    parentNode.appendChild(sldNode.cloneNode(true));
+    objRef.modified = true;
+    var attribs=[];
+    attribs["sld_body"]=(new XMLSerializer()).serializeToString(objRef.doc.selectSingleNode("//wmc:Layer[wmc:Name='"+layerName+"']/wmc:StyleList/wmc:Style/wmc:SLD/wmc:StyledLayerDescriptor"));
+	objRef.map.mbMapPane.refreshLayer(objRef.map.mbMapPane,layerName,attribs);
+	
+  }
+  this.addFirstListener( "addSLD", this.addSLD, this );
+
   /**
    * Method to remove a Layer from the LayerList
-   * @param layerName the Layer to be deleted
+   * @param layerId the Layer to be deleted
    */
-  this.deleteLayer = function(objRef, layerName) {
-    var deletedNode = objRef.getLayer(layerName);
+  this.deleteLayer = function(objRef, layerId) {
+    var deletedNode = objRef.getLayer(layerId);
     if (!deletedNode) {
-      alert("node note found; unable to delete node:"+layerName);
+      alert(mbGetMessage("nodeNotFound", layerId));
       return;
     }
     deletedNode.parentNode.removeChild(deletedNode);
@@ -258,13 +347,13 @@
 
   /**
    * Method to move a Layer in the LayerList up
-   * @param layerName the layer to be moved
+   * @param layerId the layer to be moved
    */
-  this.moveLayerUp = function(objRef, layerName) {
-    var movedNode = objRef.getLayer(layerName);
+  this.moveLayerUp = function(objRef, layerId) {
+    var movedNode = objRef.getLayer(layerId);
     var sibNode = movedNode.selectSingleNode("following-sibling::*");
     if (!sibNode) {
-      alert("can't move node past beginning of list:"+layerName);
+      alert(mbGetMessage("cantMoveUp", layerId));
       return;
     }
     movedNode.parentNode.insertBefore(sibNode,movedNode);
@@ -274,14 +363,14 @@
 
   /**
    * Method to move a Layer in the LayerList down
-   * @param layerName the layer to be moved
+   * @param layerId the layer to be moved
    */
-  this.moveLayerDown = function(objRef, layerName) {
-    var movedNode = objRef.getLayer(layerName);
+  this.moveLayerDown = function(objRef, layerId) {
+    var movedNode = objRef.getLayer(layerId);
     var listNodeArray = movedNode.selectNodes("preceding-sibling::*");  //preceding-sibling axis contains all previous siblings
     var sibNode = listNodeArray[listNodeArray.length-1];
     if (!sibNode) {
-      alert("can't move node past beginning of list:"+layerName);
+      alert(mbGetMessage("cantMoveDown", layerId));
       return;
     }
     movedNode.parentNode.insertBefore(movedNode,sibNode);
@@ -291,7 +380,7 @@
 
   /**
    * Adds a node to the Context document extension element.  The extension element
-   * will be created if it doesn't already exist.  
+   * will be created if it doesn't already exist.
    * @param extensionNode the node to be appended in the extension element.
    * @return the ndoe added to the extension element
    */
@@ -315,9 +404,9 @@
 
   /**
    * Parses a Dimension element from the Context document as a loadModel listener.
-   * This results in an XML structure with one element for each GetMap time value 
+   * This results in an XML structure with one element for each GetMap time value
    * parameter and added to the Context extrension element.
-   * @param objRef a pointer to this object 
+   * @param objRef a pointer to this object
    */
   this.initTimeExtent = function( objRef ) {
     //only the first one selected is used as the timestamp source
@@ -327,10 +416,16 @@
     for (var i=0; i<timeNodes.length; ++i) {
       var extentNode = timeNodes[i];
       objRef.timestampList = createElementWithNS(objRef.doc,"TimestampList",mbNsUrl);
-      var layerName = extentNode.parentNode.parentNode.selectSingleNode("wmc:Name").firstChild.nodeValue;
-      objRef.timestampList.setAttribute("layerName", layerName);
-      //alert("found time dimension, extent:"+extentNode.firstChild.nodeValue);
-      var times = extentNode.firstChild.nodeValue.split(",");   //comma separated list of arguments
+      var layerId;
+      var layerNode = extentNode.parentNode.parentNode;
+      if (layerNode.selectSingleNode("@id")) {
+        layerId = Mapbuilder.getProperty(layerNode, "@id");
+      } else {
+        layerId = Mapbuilder.getProperty(layerNode, "wmc:Name");
+      }
+      objRef.timestampList.setAttribute("layerId", layerId);
+      //alert("found time dimension, extent:"+getNodeValue(extentNode));
+      var times = getNodeValue(extentNode).split(",");   //comma separated list of arguments
       for (var j=0; j<times.length; ++j) {
         var params = times[j].split("/");     // parses start/end/period
         if (params.length==3) {
@@ -363,19 +458,57 @@
           objRef.timestampList.appendChild(timestamp);
         }
       }
-     objRef.setExtension(objRef.timestampList);  
+     objRef.setExtension(objRef.timestampList);
     }
   }
   this.addFirstListener( "loadModel", this.initTimeExtent, this );
+  
+  /**
+   * clear the time extent created by initTimeExtent
+   * @param objRef reference to this model
+   */
+  this.clearTimeExtent = function( objRef ) {
+    var tsList = objRef.timestampList;
+    if (tsList) {
+      tsList.parentNode.removeChild(tsList);
+    }
+  }
+  this.addListener("newModel", this.clearTimeExtent, this);
 
   /**
    * Returns the current timestamp value.
-   * @param layerName the name of the Layer from which the timestamp list was generated
+   * @param layerId the name of the Layer from which the timestamp list was generated
    * @return the current timestamp value.
    */
-  this.getCurrentTimestamp = function( layerName ) {
+  this.getCurrentTimestamp = function( layerId ) {
     var index = this.getParam("timestamp");
-    return this.timestampList.childNodes[index].firstChild.nodeValue;
+    return getNodeValue(this.timestampList.childNodes[index]);
   }
+
+  // PL -BRGM
+  /**
+   * Change a Layer's opacity
+   * @param layerId  The name of the layer that is to be changed
+   * @param Opacity     Value of the opacity
+   */
+  this.setOpacity=function(layerId, Opacity){
+    // Set the hidden attribute in the Context
+    var layer = this.getLayer(layerId);
+    if (layer) layer.setAttribute("opacity", Opacity);
+    // Call the listeners
+    this.callListeners("opacity", layerId);
+  }
+
+  /**
+   * Get the layer's opacity attribute value.
+   * @param layerId  The name of the layer that is to be changed
+   * @return hidden  String with the value; 1=hidden, 0=visible.
+   */
+  this.getOpacity=function(layerId){
+    var opacity=1;
+    var layer = this.getLayer(layerId);
+    if (layer) opacity = layer.getAttribute("opacity");
+    return opacity;
+  }
+  // PL -END
 }
-
Index: lib/spatial/mapbuilder/lib/Mapbuilder.js
===================================================================
--- lib/spatial/mapbuilder/lib/Mapbuilder.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/Mapbuilder.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Mapbuilder.js 3819 2008-02-01 00:31:29Z ahocevar $
 */
 
 /** get a time stamp at start of the page load */
@@ -9,8 +9,10 @@
 /** the global config object */
 var config;
 
+if( typeof baseDir == "undefined") {
 /** URL of Mapbuilder's lib/ directory. */
 var baseDir;
+}
 
 /** mapbuilder environement settings, defaults to a .xml extension but is 
   auto-configured by the ant build script to .jsp for tomcat environment 
@@ -52,6 +54,12 @@
   /** Array of objects that are loading.  Don't continue initialisation until
    * all objects have loaded. */
   this.loadingScripts=new Array();
+  
+  /** Array of scripts that have to be loaded ordered */
+  this.orderedScripts = new Array();
+  
+  /** Timer to load ordered scripts */
+  this.scriptLoader = null;
 
   /** Timer to periodically check if scripts have loaded. */
   this.scriptsTimer=null;
@@ -74,7 +82,7 @@
       {
         this.loadingScripts.shift();
       }
-      if (this.loadingScripts.length==0){
+      if (this.loadingScripts.length==0 && this.orderedScripts.length == 0){
         this.setLoadState(this.loadState+1);
       }
     }
@@ -95,14 +103,22 @@
     this.loadState=newState;
     switch (newState){
       case MB_LOAD_CORE:
+        // core scripts have to be loaded in the correct order (needed for IE)
+        this.loadOrdered = true;
+        this.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
         this.loadScript(baseDir+"/util/sarissa/Sarissa.js");
-        //this.loadScript(baseDir+"/util/sarissa/sarissa_dhtml.js");
+        this.loadScript(baseDir+"/util/sarissa/javeline_xpath.js");
+        this.loadScript(baseDir+"/util/sarissa/javeline_xslt.js");
+        this.loadScript(baseDir+"/util/sarissa/sarissa_dhtml.js");
         this.loadScript(baseDir+"/util/sarissa/sarissa_ieemu_xpath.js");
         //this.loadScript(baseDir+"/util/sarissa/sarissa_ieemu_xslt.js");//all deprecated
+        this.loadScript(baseDir+"/util/proj4js/proj4js-compressed.js");
         this.loadScript(baseDir+"/util/Util.js");
         this.loadScript(baseDir+"/util/Listener.js");
         this.loadScript(baseDir+"/model/ModelBase.js");
         this.loadScript(baseDir+"/model/Config.js");
+        // from now on, scripts can be loaded in any order
+        this.loadOrdered = false;
         break;
       case MB_LOAD_CONFIG:
         if(document.readyState){
@@ -115,29 +131,7 @@
         }
         break;
       case MB_LOADED:
-        clearInterval(this.scriptsTimer);
-          
-        /*
-         *  Test for XSLT support
-         *  if not, redirect to an appropriate message.
-         */
-        if (typeof XSLTProcessor != "undefined") {
-           var UA = navigator.userAgent;
-           var AV = navigator.appVersion;
-
-           // KHTML browsers should be detected by the typeof comparison
-           //khtml = ((AV.indexOf("Konqueror") >= 0)||(AV.indexOf("Safari") >= 0)) ? true : false;
-
-           // Opera slips through the cracks
-           opera = UA.indexOf("Opera") == -1 ? false : true;
-
-           if (opera) {
-               window.location = baseDir+"/util/noxslt.html";
-           }
-        } else {
-           window.location = baseDir+"/util/noxslt.html";
-        }
-
+        window.clearInterval(this.scriptsTimer);
         break;
     }
   }
@@ -145,18 +139,91 @@
   /**
    * Dynamically load a script file if it has not already been loaded.
    * @param url The url of the script.
+   * that loadScript was called
    */
   this.loadScript=function(url){
+    // if we are working with a compressed build, load only scripts that
+    // are not part of the compressed build. This check is done by looking
+    // into the global namespace for a function that has the same name as
+    // the script file (without path and without .js). Because script files
+    // in the util dir do not follow that pattern, exclude them from the
+    // check separately.
+    if(typeof MapBuilder_Release == "boolean") {
+      if (url.indexOf(baseDir+"/util/") != -1) {
+        return;
+      }
+      var urlElements = url.split("/");
+      var scriptClass = urlElements[urlElements.length-1].replace(/.js$/, "");
+      if(typeof window[scriptClass] == "function") {
+        return;
+      }
+    }
+
     if(!document.getElementById(url)){
       var script = document.createElement('script');
+      script.src = url;
+      script.id = url;
       script.defer = false;   //not sure of effect of this?
       script.type = "text/javascript";
-      script.src = url;
-      script.id = url;
-      document.getElementsByTagName('head')[0].appendChild(script);
-      this.loadingScripts.push(script);
+      if (document.readyState && this.loadOrdered == true) {
+        // in IE, mark the script as ordered
+        this.orderedScripts.push(script);
+        if (!this.scriptLoader) {
+          this.scriptLoader = window.setInterval('mapbuilder.loadNextScript()', 50);
+        }
+      } else {
+        // add to dom tree, except if we are using IE and want to load ordered
+        document.getElementsByTagName('head')[0].appendChild(script);
+      }
+      if (document.readyState) {
+        // this is only needed for IE
+        this.loadingScripts.push(script);
+      }
     }
   }
+   
+  /**
+   * loads one script after another - only for IE. This function is run in a
+   * 50ms interval and clears its interval if there are no more scripts to
+   * load. It actually loads the first script from the orderedScripts array.
+   */
+  this.loadNextScript = function() {
+    if (this.orderedScripts.length == 0) {
+      window.clearInterval(this.scriptLoader);
+      this.scriptLoader = null;
+    } else {
+      var script = this.orderedScripts[0];
+      if (!script.loading) {
+        script.loading = true;
+        this.doLoadScript(script);
+      }
+    }
+  }
+  
+  /**
+   * starts script loading by adding the script node to the dom tree - IE only.
+   * This function adds a readyState handler to the script node.
+   */
+  this.doLoadScript = function(script) {
+    var objRef = this;
+    script.onreadystatechange = function(){objRef.checkScriptState(this)};
+    document.getElementsByTagName('head')[0].appendChild(script);
+  }
+  
+  /**
+   * readyState handler for scripts - IE only. This will remove the script from
+   * the array of scripts that have still to be loaded.
+   */
+  this.checkScriptState = function(script) {
+    if (script.readyState == "loaded" || script.readyState == "complete") {
+      for (var i=0; i<this.orderedScripts.length; i++) {
+        if (script == this.orderedScripts[i]) {
+          this.orderedScripts.splice(i, 1);
+          break;
+        }
+      }
+    }
+  }
 
   /**
    * Internal function to load scripts for components that don't have <scriptfile>
@@ -175,14 +242,23 @@
   }
 
   //derive the baseDir value by looking for the script tag that loaded this file
-  var head = document.getElementsByTagName('head')[0];
-  var nodes = head.childNodes;
-  for (var i=0; i<nodes.length; ++i ){
-    var src = nodes.item(i).src;
-    if (src) {
-      var index = src.indexOf("/Mapbuilder.js");
-      if (index>=0) {
-        baseDir = src.substring(0, index);
+  if (!baseDir) {
+    var head = document.getElementsByTagName('head')[0];
+    var nodes = head.childNodes;
+    for (var i=0; i<nodes.length; ++i ){
+      var src = nodes.item(i).src;
+      if (src) {
+        //var index = src.indexOf("/Mapbuilder.js");
+        // Modified so it will work with original or compressed file
+        var index = src.indexOf("/Mapbuilder.js");
+        if (index>=0) {
+          baseDir = src.substring(0, index);
+        } else {
+          index = src.indexOf("/MapbuilderCompressed.js");
+          if (index>=0) {
+            baseDir = src.substring(0, index);
+          }
+        }
       }
     }
   }
@@ -191,7 +267,7 @@
   this.setLoadState(MB_LOAD_CORE);
 
   // Start a timer which periodically calls checkScriptsLoaded().
-  this.scriptsTimer=setInterval('mapbuilder.checkScriptsLoaded()',100);
+  this.scriptsTimer=window.setInterval('mapbuilder.checkScriptsLoaded()',100);
 }
 
 /**
@@ -224,8 +300,12 @@
  */
 function mapbuilderInit(){
   if(mapbuilder && mapbuilder.loadState==MB_LOADED){
-    clearInterval(mbTimerId);
+    window.clearInterval(mbTimerId);
     config.parseConfig(config);
+    if (Proj4js) {
+      Proj4js.libPath = baseDir+"/util/proj4js/";
+      Proj4js.proxyScript = config.proxyUrl+'?url=';
+    }
     config.callListeners("init");
     var mbTimerStop = new Date();
     //alert("load time:"+(mbTimerStop.getTime()-mbTimerStart.getTime()) );
@@ -247,6 +327,6 @@
  */
 function mbDoLoad(initFunction) {
   // See if scripts have been loaded every 100msecs, then call config.init().
-  mbTimerId=setInterval('mapbuilderInit()',100);
+  mbTimerId=window.setInterval('mapbuilderInit()',100);
   if (initFunction) window.mbInit = initFunction;
 }
Index: lib/spatial/mapbuilder/lib/model/WfsCapabilities.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/WfsCapabilities.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/WfsCapabilities.js	(revision 4307)
@@ -1,13 +1,17 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: WfsCapabilities.js 3657 2007-11-29 09:04:26Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Stores a Web Feature (WFS) Capabilities document as defined by the 
- * Open Geospatial Consortium (http://opengis.org).
+ * Open Geospatial Consortium (http://www.opengeospatial.org/).
  *
  * @constructor
+ * @base ModelBase
  * @author Mike Adair
  * @param modelNode   The model's XML object node from the configuration document.
  * @param parent The model object that this widget belongs to.
Index: lib/spatial/mapbuilder/lib/model/Model.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/Model.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/Model.js	(revision 4307)
@@ -1,8 +1,11 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Model.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Generic Model object for models where no specialization is required.  This is
  * just an instance of a abstract ModelBase.
Index: lib/spatial/mapbuilder/lib/model/Logger.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/Logger.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/Logger.js	(revision 4307)
@@ -1,8 +1,11 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Logger.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Records a log of events that occur over the course of mapbuilder execution
  * @constructor
@@ -59,9 +62,9 @@
       Sarissa.setXpathNamespaces(tempDoc, "xmlns:xlink='http://www.w3.org/1999/xlink'");
       var onlineResource = tempDoc.selectSingleNode("//OnlineResource");
       var fileUrl = onlineResource.attributes.getNamedItem("xlink:href").nodeValue;
-      alert("event log saved as:" + fileUrl);
+      alert(mbGetMessage("eventLogSaved", fileUrl));
     } else {
-      alert("unable to save event log; provide a serializeUrl property in config");
+      alert(mbGetMessage("unableToSaveLog"));
     }
   }
 
Index: lib/spatial/mapbuilder/lib/model/Transaction.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/Transaction.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/Transaction.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Transaction.js 3657 2007-11-29 09:04:26Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -7,13 +7,14 @@
 mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
 
 /**
- * Stores a WFS Transaction reponse as defined by the Open GIS Consortium
- * http://opengis.org (WFS).  
+ * Stores a WFS Transaction reponse as defined by the Open Geospatial Consortium
+ * (http://www.opengeospatial.org/) (WFS).  
  * Extends ModelBase, which extends Listener.
  *
  * Listeners implemented:
  *
  * @constructor
+ * @base ModelBase
  * @author Mike Adair
  * @param modelNode Pointer to the xml node for this model from the config file.
  * @param parent    The parent model for the object.
